﻿
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

var sErrorMSG="";
function setWithRetryOneValue(deviceObj,value,bank,index,iRetry, fFehlertolerant) {
    var checkValue=-1;
	try {
		deviceObj.setConfig(bank,index,value);
		checkValue=deviceObj.getConfig(bank,index);
	} 
	catch (e) {
		lWarn.logln("Fehler beim Schreiben : B" + bank + " I" + index + " R:" + iRetry + " Val:" + value); 
	}
    if (fFehlertolerant==null)
        fFehlertolerant=false;
    if (!fFehlertolerant) {
        if (checkValue!=value) {
            if (iRetry>0) {
                lInfo.logln('Fehler: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue + ' noch ' + iRetry + ' Versuche');
                return setWithRetryOneValue(deviceObj,value,bank,index,iRetry-1);
            } else {
                sErrorMSG+='Letzer Versuch: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue ;
                lInfo.logln(sErrorMSG );
                return false;
            }
        } else {
            lInfo.logln('OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
            return true;
        }
    }
    lInfo.logln('(vielleicht) OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
    return true;
}

function prepareStep(step,currentDevice, maxNrOfDevices) {
    try {
        var action = Property.getNode('temp/action').getValue();
        lInfo.logln('prepareStep called with step: ' + step + ' currentDevice: ' + currentDevice + ' maxNrOfDevices: ' + maxNrOfDevices + ' action: ' + action);
        switch (action) {
            case 'delete': {            
                new Event('led-wizard.answer',{type:'step',detail:'complete',error:false,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'complete',error:false,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices,massProgPath:raisedEvent.parameter.massProgPath}).raise();              
            }
            break;
            case 'errorParamList': {
                new Event('led-wizard.answer',{type:'step',detail:'complete',error:true,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'complete',error:true, currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices,massProgPath:raisedEvent.parameter.massProgPath}).raise();                          
            }
            break;
            case 'programm': {
                new Event('led-wizard.answer',{type:'step',detail:'step',index:step,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'step',index:step,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices,massProgPath:raisedEvent.parameter.massProgPath}).raise();                           
            }
            break;
            default: {
                new Event('led-wizard.answer',{type:'step',detail:'complete',error:true,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'complete',error:true, currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices,massProgPath:raisedEvent.parameter.massProgPath}).raise();                                      
            }
        }
    } catch (e) {
        lWarn.logln('Exception in prepareStep: ' + e);
    }
}
    
function makeStep(deviceIndex, maxNrOfDevices){
    try {
    	var dsuid=Property.getNode('temp/dsuid').getValue();
    	var array=Property.getNode('temp/value').getValue();
    	var step=Property.getNode('temp/step').getValue();
    	lInfo.logln("step " + step  + " for  " + dsuid);
    	array = array.replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&#039;/g, '\'');
    	var oArray=JSON.parse(array);
    	 
    	var oDevice=getDevices().byDSUID(dsuid);
        if (oDevice==null) {
            sErrorMSG='Ger�t ' + dsuid + ' nicht gefunden';
            lWarn.logln(sErrorMSG);
            new Event('led-wizard.step',{detail:'complete',error:true, currentDevice:deviceIndex, maxNrOfDevices: maxNrOfDevices}).raise();
            new Event('led-wizard.answer',{detail:'complete',type:'step',error:true, currentDevice:deviceIndex, maxNrOfDevices: maxNrOfDevices}).raise();
            Property.setProperty(raisedEvent.parameter.massProgPath + '/state',-1);
            return;
        }
    	if (step+1 < oArray.length)
    	{
            setWithRetryOneValue(oDevice,oArray[step].value,oArray[step].bank,oArray[step].offset,3);
            Property.setProperty('temp/step', step+1);
            lInfo.logln('OK schicke step ' + (step+1));
            new Event('led-wizard.step',{detail:'step','index':step+1, 'currentDevice':deviceIndex,'maxNrOfDevices': maxNrOfDevices,massProgPath:raisedEvent.parameter.massProgPath}).raise();    
            new Event('led-wizard.answer',{detail:'step',type:'step','index':step+1,'currentDevice':deviceIndex,'maxNrOfDevices': maxNrOfDevices}).raise();  
    
    	} else {
    	    //last step
            setWithRetryOneValue(oDevice,oArray[step].value,oArray[step].bank,oArray[step].offset,3);
            lInfo.logln('Ende erreicht, schicke complete');
            new Event('led-wizard.step',{detail:'complete',error:false,currentDevice:deviceIndex,maxNrOfDevices: maxNrOfDevices,massProgPath:raisedEvent.parameter.massProgPath}).raise();
            new Event('led-wizard.answer',{detail:'complete',type:'step',error:false,currentDevice:deviceIndex,maxNrOfDevices: maxNrOfDevices}).raise();
    	}
    } catch (e) {
        lWarn.logln('Exception in makeStep: ' + e);
    }
}

function getSupplierID(curve_id) {
	var node=Property.getNode('references');
	if (node==null)
		return null;
	var oArray=node.getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		var iReferenceArray=JSON.parse(oArray[iIndex].getValue());
		for (var jIndex=0;jIndex<iReferenceArray.length;jIndex++)
			if (""+curve_id==""+iReferenceArray[jIndex])
				return oArray[iIndex].getName();	
	} 
	return null;
}

function makeComplete(deviceIndex, maxNrOfDevices){
    try {
    	lInfo.logln('ende device nr ' + deviceIndex + ' of ' + maxNrOfDevices + ', bereinige Daten ');
        
    	var dsuid=Property.getNode('temp/dsuid').getValue();
    	var id=Property.getNode('temp/catalogeID').getValue();
    	
    	if (id==-1) {
    		Property.getNode('devices').removeChild(dsuid);
    	} else {
    		storeSubParameter('devices/' + dsuid + '/dsuid' , dsuid);
        	storeSubParameter('devices/' + dsuid + '/catalogeID' , id);
        	storeSubParameter('devices/' + dsuid + '/ts' , ""+(new Date()).getTime());
        	
        	supplierID=getSupplierID(id);
        	lInfo.logln('curve ' + id + ' supplier: ' + supplierID);
        	new Event('led-wizard.query-'+ supplierID,{actions:'cleanup'}).raise();
        	
    	}
    	var oNode=Property.getNode(raisedEvent.parameter.massProgPath);
    	oNode.getParent().removeChild(oNode.getName());
    	
    	var oMassProgArray=Property.getNode('massProg').getChildren();
		for (var iIndex=0;iIndex<oMassProgArray.length;iIndex++) {
			if (oMassProgArray[iIndex].getChild('state').getValue()==1) {
				lWarn.logln('after programming found a stuck previous programming, set it to Error with ' + 
						oMassProgArray[iIndex].getChild('curve_id').getValue()+ ' for ' + 
						oMassProgArray[iIndex].getChild('dsuid').getValue());
				oMassProgArray[iIndex].getChild('state').setValue(-3);
			}
		}
    	
    
        Property.store();
        new Event('led-wizard.prog',{actions:'programmCurveStartQueue','time':'+1'}).raise();

    } catch (e) {
        lWarn.logln('Exception in makeComplete: ' + e);
    }
}

for (var sKey in raisedEvent.parameter) {
	lInfo.logln(' key ' + sKey + ' : '+ raisedEvent.parameter[sKey]);
}
if (raisedEvent.parameter.detail != null) {
	if (raisedEvent.parameter.detail == 'step') {		
		makeStep(raisedEvent.parameter.currentDevice, raisedEvent.parameter.maxNrOfDevices);
    }
	if (raisedEvent.parameter.detail == 'complete') {		
	    makeComplete(raisedEvent.parameter.currentDevice, raisedEvent.parameter.maxNrOfDevices);
    }
	if (raisedEvent.parameter.detail == 'prepare') {
	    lInfo.logln('Prepare event: count: ' + raisedEvent.parameter.count + ' currentDevice: ' + raisedEvent.parameter.currentDevice + ' maxNrOfDevices: '  + raisedEvent.parameter.maxNrOfDevices);
	    Property.setProperty('temp/step', 0);
	    prepareStep(0, raisedEvent.parameter.currentDevice, raisedEvent.parameter.maxNrOfDevices);
	}
}

	